>From 716c9ad8b89c212a6acbad9b6349d70791bb18bf Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Tue, 20 Nov 2012 14:15:36 -0500
Subject: [PATCH 90/90] Removed obsolete cmake modules, updated spec files

---
 cmake/Modules/FindJNI.cmake     | 256 ----------------------------------------
 cmake/Modules/FindOpenSSL.cmake | 143 ----------------------
 cmake/Modules/FindZLIB.cmake    |  69 -----------
 specs/pki-console.spec          |  23 +---
 specs/pki-core.spec             |   3 +-
 specs/pki-ra.spec               |  54 +--------
 specs/pki-tps.spec              |  56 +--------
 7 files changed, 20 insertions(+), 584 deletions(-)
 delete mode 100644 cmake/Modules/FindJNI.cmake
 delete mode 100644 cmake/Modules/FindOpenSSL.cmake
 delete mode 100644 cmake/Modules/FindZLIB.cmake

diff --git a/cmake/Modules/FindJNI.cmake b/cmake/Modules/FindJNI.cmake
deleted file mode 100644
index 953dc856bd090cd7ffdbb271170471026e212470..0000000000000000000000000000000000000000
--- a/cmake/Modules/FindJNI.cmake
+++ /dev/null
@@ -1,256 +0,0 @@
-# - Find JNI java libraries.
-# This module finds if Java is installed and determines where the
-# include files and libraries are. It also determines what the name of
-# the library is. This code sets the following variables:
-#
-#  JNI_INCLUDE_DIRS      = the include dirs to use
-#  JNI_LIBRARIES         = the libraries to use
-#  JAVA_AWT_LIBRARY      = the path to the jawt library
-#  JAVA_JVM_LIBRARY      = the path to the jvm library
-#  JAVA_INCLUDE_PATH     = the include path to jni.h
-#  JAVA_INCLUDE_PATH2    = the include path to jni_md.h
-#  JAVA_AWT_INCLUDE_PATH = the include path to jawt.h
-#
-
-#=============================================================================
-# Copyright 2001-2009 Kitware, Inc.
-#
-# Distributed under the OSI-approved BSD License (the "License");
-# see accompanying file Copyright.txt for details.
-#
-# This software is distributed WITHOUT ANY WARRANTY; without even the
-# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-# See the License for more information.
-#=============================================================================
-# (To distributed this file outside of CMake, substitute the full
-#  License text for the above reference.)
-
-# Expand {libarch} occurences to java_libarch subdirectory(-ies) and set ${_var}
-macro(JAVA_APPEND_LIBRARY_DIRECTORIES _var)
-    # Determine java arch-specific library subdir
-    if (CMAKE_SYSTEM_NAME MATCHES "Linux")
-        # Based on openjdk/jdk/make/common/shared/Platform.gmk as of 6b16
-        # and kaffe as of 1.1.8 which uses the first part of the
-        # GNU config.guess platform triplet.
-        if (CMAKE_SYSTEM_PROCESSOR MATCHES "^i[3-9]86$")
-            set(_java_libarch "i386")
-        elseif (CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
-            set(_java_libarch "amd64" "x86_64")
-        elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "^ppc")
-            set(_java_libarch "ppc" "powerpc" "ppc64")
-        elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "^sparc")
-            set(_java_libarch "sparc" "sparcv9")
-        elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "^arm")
-            set(_java_libarch "arm")
-        else (CMAKE_SYSTEM_PROCESSOR MATCHES "^i[3-9]86$")
-            set(_java_libarch "${CMAKE_SYSTEM_PROCESSOR}")
-        endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^i[3-9]86$")
-    else (CMAKE_SYSTEM_NAME MATCHES "Linux")
-        set(_java_libarch "i386" "amd64" "ppc") # previous default
-    endif (CMAKE_SYSTEM_NAME MATCHES "Linux")
-
-    foreach(_path ${ARGN})
-        if (_path MATCHES "{libarch}")
-            foreach(_libarch ${_java_libarch})
-                string(REPLACE "{libarch}" "${_libarch}" _newpath "${_path}")
-                list(APPEND ${_var} "${_newpath}")
-            endforeach(_libarch)
-        else (_path MATCHES "{libarch}")
-            list(APPEND ${_var} "${_path}")
-        endif (_path MATCHES "{libarch}")
-    endforeach(_path)
-endmacro(JAVA_APPEND_LIBRARY_DIRECTORIES)
-
-file(TO_CMAKE_PATH "$ENV{JAVA_HOME}" _JAVA_HOME)
-
-get_filename_component(java_install_version
-  "[HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Development Kit;CurrentVersion]" NAME
-)
-
-set(JAVA_AWT_LIBRARY_DIRECTORIES
-    "[HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Development Kit\\1.4;JavaHome]/lib"
-    "[HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Development Kit\\1.3;JavaHome]/lib"
-    "[HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Development Kit\\${java_install_version};JavaHome]/lib"
-)
-
-
-java_append_library_directories(JAVA_AWT_LIBRARY_DIRECTORIES
-    ${_JAVA_HOME}/jre/lib/{libarch}
-    ${_JAVA_HOME}/jre/lib
-    ${_JAVA_HOME}/lib
-    ${_JAVA_HOME}
-    /usr/lib
-    /usr/local/lib
-    /usr/lib/jvm/java/lib
-    /usr/lib/java/jre/lib/{libarch}
-    /usr/local/lib/java/jre/lib/{libarch}
-    /usr/local/share/java/jre/lib/{libarch}
-    /usr/lib/j2sdk1.4-sun/jre/lib/{libarch}
-    /usr/lib/j2sdk1.5-sun/jre/lib/{libarch}
-    /opt/sun-jdk-1.5.0.04/jre/lib/{libarch}
-    /usr/lib/jvm/java-6-sun/jre/lib/{libarch}
-    /usr/lib/jvm/java-1.5.0-sun/jre/lib/{libarch}
-    /usr/lib/jvm/java-6-sun-1.6.0.00/jre/lib/{libarch}       # can this one be removed according to #8821 ? Alex
-    /usr/lib/jvm/java-openjdk/jre/lib/{libarch}
-    /usr/lib/jvm/java-6-openjdk/jre/lib/{libarch}
-    /usr/lib/jvm/java-openjdk/jre/lib/{libarch}
-    # Debian specific paths for default JVM
-    /usr/lib/jvm/default-java/jre/lib/{libarch}
-    /usr/lib/jvm/default-java/jre/lib
-    /usr/lib/jvm/default-java/lib
-)
-
-set(JAVA_JVM_LIBRARY_DIRECTORIES)
-foreach (dir ${JAVA_AWT_LIBRARY_DIRECTORIES})
-    set(JAVA_JVM_LIBRARY_DIRECTORIES
-        ${JAVA_JVM_LIBRARY_DIRECTORIES}
-        "${dir}"
-        "${dir}/client"
-        "${dir}/server"
-    )
-endforeach (dir)
-
-
-set(JAVA_AWT_INCLUDE_DIRECTORIES
-    "[HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Development Kit\\1.4;JavaHome]/include"
-    "[HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Development Kit\\1.3;JavaHome]/include"
-    "[HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Development Kit\\${java_install_version};JavaHome]/include"
-    ${_JAVA_HOME}/include
-    /usr/include
-    /usr/local/include
-    /usr/lib/java/include
-    /usr/local/lib/java/include
-    /usr/lib/jvm/java/include
-    /usr/lib/jvm/java-6-sun/include
-    /usr/lib/jvm/java-1.5.0-sun/include
-    /usr/lib/jvm/java-6-sun-1.6.0.00/include       # can this one be removed according to #8821 ? Alex
-    /usr/lib/jvm/java-6-openjdk/include
-    /usr/local/share/java/include
-    /usr/lib/j2sdk1.4-sun/include
-    /usr/lib/j2sdk1.5-sun/include
-    /opt/sun-jdk-1.5.0.04/include
-    # Debian specific path for default JVM
-    /usr/lib/jvm/default-java/include
-)
-
-foreach(JAVA_PROG "${JAVA_RUNTIME}" "${JAVA_COMPILE}" "${JAVA_ARCHIVE}" "${JAVA_HEADER}")
-    get_filename_component(jpath "${JAVA_PROG}" PATH)
-    foreach (JAVA_INC_PATH ../include ../java/include ../share/java/include)
-        if (EXISTS ${jpath}/${JAVA_INC_PATH})
-            set(JAVA_AWT_INCLUDE_DIRECTORIES
-                ${JAVA_AWT_INCLUDE_DIRECTORIES}
-                "${jpath}/${JAVA_INC_PATH}"
-            )
-        endif (EXISTS ${jpath}/${JAVA_INC_PATH})
-    endforeach (JAVA_INC_PATH)
-
-    foreach (JAVA_LIB_PATH
-            ../lib ../jre/lib ../jre/lib/i386
-            ../java/lib ../java/jre/lib ../java/jre/lib/i386
-            ../share/java/lib ../share/java/jre/lib ../share/java/jre/lib/i386)
-        if (EXISTS ${jpath}/${JAVA_LIB_PATH})
-            set(JAVA_AWT_LIBRARY_DIRECTORIES
-                ${JAVA_AWT_LIBRARY_DIRECTORIES}
-                "${jpath}/${JAVA_LIB_PATH}"
-            )
-        endif (EXISTS ${jpath}/${JAVA_LIB_PATH})
-    endforeach (JAVA_LIB_PATH)
-endforeach (JAVA_PROG)
-
-if (APPLE)
-    if (EXISTS ~/Library/Frameworks/JavaVM.framework)
-        set(JAVA_HAVE_FRAMEWORK 1)
-    endif (EXISTS ~/Library/Frameworks/JavaVM.framework)
-
-    if (EXISTS /Library/Frameworks/JavaVM.framework)
-        SET(JAVA_HAVE_FRAMEWORK 1)
-    endif (EXISTS /Library/Frameworks/JavaVM.framework)
-
-    if (EXISTS /System/Library/Frameworks/JavaVM.framework)
-        set(JAVA_HAVE_FRAMEWORK 1)
-    endif(EXISTS /System/Library/Frameworks/JavaVM.framework)
-
-    if (JAVA_HAVE_FRAMEWORK)
-        if(NOT JAVA_AWT_LIBRARY)
-            set(JAVA_AWT_LIBRARY "-framework JavaVM" CACHE FILEPATH "Java Frameworks" FORCE)
-        endif(NOT JAVA_AWT_LIBRARY)
-
-        if (NOT JAVA_JVM_LIBRARY)
-            set (JAVA_JVM_LIBRARY "-framework JavaVM" CACHE FILEPATH "Java Frameworks" FORCE)
-        endif (NOT JAVA_JVM_LIBRARY)
-
-        if (NOT JAVA_AWT_INCLUDE_PATH)
-            if (EXISTS /System/Library/Frameworks/JavaVM.framework/Headers/jawt.h)
-                set(JAVA_AWT_INCLUDE_PATH "/System/Library/Frameworks/JavaVM.framework/Headers" CACHE FILEPATH "jawt.h location" FORCE)
-            endif(EXISTS /System/Library/Frameworks/JavaVM.framework/Headers/jawt.h)
-        endif (NOT JAVA_AWT_INCLUDE_PATH)
-
-        #
-        # If using "-framework JavaVM", prefer its headers *before* the others in
-        # JAVA_AWT_INCLUDE_DIRECTORIES... (*prepend* to the list here)
-        #
-        set(JAVA_AWT_INCLUDE_DIRECTORIES
-            ~/Library/Frameworks/JavaVM.framework/Headers
-            /Library/Frameworks/JavaVM.framework/Headers
-            /System/Library/Frameworks/JavaVM.framework/Headers
-            ${JAVA_AWT_INCLUDE_DIRECTORIES}
-        )
-    endif(JAVA_HAVE_FRAMEWORK)
-else (APPLE)
-    find_library(JAVA_AWT_LIBRARY
-        NAMES
-            jawt
-        PATHS
-            ${JAVA_AWT_LIBRARY_DIRECTORIES}
-    )
-
-    find_library(JAVA_JVM_LIBRARY
-        NAMES
-            jvm
-            JavaVM
-        PATHS
-            ${JAVA_JVM_LIBRARY_DIRECTORIES}
-    )
-endif (APPLE)
-
-# add in the include path
-find_path(JAVA_INCLUDE_PATH
-    NAMES
-        jni.h
-    PATHS
-        ${JAVA_AWT_INCLUDE_DIRECTORIES}
-)
-
-find_path(JAVA_INCLUDE_PATH2
-    NAMES
-        jni_md.h
-    PATHS
-        ${JAVA_INCLUDE_PATH}
-        ${JAVA_INCLUDE_PATH}/win32
-        ${JAVA_INCLUDE_PATH}/linux
-        ${JAVA_INCLUDE_PATH}/freebsd
-        ${JAVA_INCLUDE_PATH}/solaris
-)
-
-find_path(JAVA_AWT_INCLUDE_PATH
-    NAMES
-        jawt.h
-    PATHS
-        ${JAVA_INCLUDE_PATH}
-)
-
-set(JNI_LIBRARIES
-    ${JAVA_AWT_LIBRARY}
-    ${JAVA_JVM_LIBRARY}
-)
-
-set(JNI_INCLUDE_DIRS
-    ${JAVA_INCLUDE_PATH}
-    ${JAVA_INCLUDE_PATH2}
-    ${JAVA_AWT_INCLUDE_PATH}
-)
-
-include(FindPackageHandleStandardArgs)
-find_package_handle_standard_args(JNI DEFAULT_MSG JNI_LIBRARIES JNI_INCLUDE_DIRS JAVA_AWT_LIBRARY JAVA_JVM_LIBRARY)
-
-mark_as_advanced(JNI_LIBRARIES JNI_INCLUDE_DIRS JAVA_AWT_LIBRARY JAVA_JVM_LIBRARY)
diff --git a/cmake/Modules/FindOpenSSL.cmake b/cmake/Modules/FindOpenSSL.cmake
deleted file mode 100644
index 05126f1d2a75aff1a55bda1d7dc897ac1e707345..0000000000000000000000000000000000000000
--- a/cmake/Modules/FindOpenSSL.cmake
+++ /dev/null
@@ -1,143 +0,0 @@
-# - Try to find OpenSSL
-# Once done this will define
-#
-#  OPENSSL_FOUND - system has OpenSSL
-#  OPENSSL_INCLUDE_DIRS - the OpenSSL include directory
-#  OPENSSL_LIBRARIES - Link these to use OpenSSL
-#  OPENSSL_DEFINITIONS - Compiler switches required for using OpenSSL
-#
-#  Copyright (c) 2009-2010 Andreas Schneider <mail@cynapses.org>
-#
-#  Redistribution and use is allowed according to the terms of the New
-#  BSD license.
-#  For details see the accompanying COPYING-CMAKE-SCRIPTS file.
-#
-
-
-if (OPENSSL_LIBRARIES AND OPENSSL_INCLUDE_DIRS)
-  # in cache already
-  set(OPENSSL_FOUND TRUE)
-else (OPENSSL_LIBRARIES AND OPENSSL_INCLUDE_DIRS)
-  if (WIN32)
-    set(_OPENSSL_DIR $ENV{PROGRAMFILES}/OpenSSL)
-  endif (WIN32)
-
-  find_package(PkgConfig)
-  if (PKG_CONFIG_FOUND)
-    pkg_check_modules(_OPENSSL openssl)
-  endif (PKG_CONFIG_FOUND)
-
-  find_path(OPENSSL_INCLUDE_DIR
-    NAMES
-      openssl/ssl.h
-    PATHS
-      ${_OPENSSL_DIR}/include
-      ${_OPENSSL_INCLUDEDIR}
-      /usr/include
-      /usr/local/include
-      /opt/local/include
-      /sw/include
-      /usr/lib/sfw/include
-  )
-
-  find_library(SSL_LIBRARY
-    NAMES
-      ssl
-      libssl
-    PATHS
-      ${_OPENSSL_DIR}/lib
-      ${_OPENSSL_LIBDIR}
-      /usr/lib
-      /usr/local/lib
-      /opt/local/lib
-      /sw/lib
-      /usr/sfw/lib/64
-      /usr/sfw/lib
-  )
-
-  find_library(SSLEAY32_LIBRARY
-    NAMES
-      ssleay32
-    PATHS
-      ${_OPENSSL_DIR}/lib
-      ${_OPENSSL_LIBDIR}
-      /usr/lib
-      /usr/local/lib
-      /opt/local/lib
-      /sw/lib
-      /usr/sfw/lib/64
-      /usr/sfw/lib
-  )
-
-  find_library(SSLEAY32MD_LIBRARY
-    NAMES
-      ssleay32MD
-    PATHS
-      ${_OPENSSL_DIR}/lib
-      ${_OPENSSL_LIBDIR}
-      /usr/lib
-      /usr/local/lib
-      /opt/local/lib
-      /sw/lib
-      /usr/sfw/lib/64
-      /usr/sfw/lib
-  )
-
-  find_library(CRYPTO_LIBRARY
-    NAMES
-      crypto
-      libcrypto
-      eay
-      eay32
-      libeay
-      libeay32
-    PATHS
-      ${_OPENSSL_DIR}/lib
-      ${_OPENSSL_LIBDIR}
-      /usr/lib
-      /usr/local/lib
-      /opt/local/lib
-      /sw/lib
-      /usr/sfw/lib/64
-      /usr/sfw/lib
-  )
-
-  set(OPENSSL_INCLUDE_DIRS
-    ${OPENSSL_INCLUDE_DIR}
-  )
-
-  if (SSL_LIBRARY)
-    set(OPENSSL_LIBRARIES
-        ${OPENSSL_LIBRARIES}
-        ${SSL_LIBRARY}
-    )
-  endif (SSL_LIBRARY)
-
-  if (SSLEAY32_LIBRARY)
-    set(OPENSSL_LIBRARIES
-        ${OPENSSL_LIBRARIES}
-        ${SSLEAY32_LIBRARY}
-    )
-  endif (SSLEAY32_LIBRARY)
-
-  if (SSLEAY32MD_LIBRARY)
-    set(OPENSSL_LIBRARIES
-        ${OPENSSL_LIBRARIES}
-        ${SSLEAY32MD_LIBRARY}
-    )
-  endif (SSLEAY32MD_LIBRARY)
-
-  if (CRYPTO_LIBRARY)
-    set(OPENSSL_LIBRARIES
-        ${OPENSSL_LIBRARIES}
-        ${CRYPTO_LIBRARY}
-    )
-  endif (CRYPTO_LIBRARY)
-
-  include(FindPackageHandleStandardArgs)
-  find_package_handle_standard_args(OpenSSL DEFAULT_MSG OPENSSL_LIBRARIES OPENSSL_INCLUDE_DIRS)
-
-  # show the OPENSSL_INCLUDE_DIRS and OPENSSL_LIBRARIES variables only in the advanced view
-  mark_as_advanced(OPENSSL_INCLUDE_DIRS OPENSSL_LIBRARIES)
-
-endif (OPENSSL_LIBRARIES AND OPENSSL_INCLUDE_DIRS)
diff --git a/cmake/Modules/FindZLIB.cmake b/cmake/Modules/FindZLIB.cmake
deleted file mode 100644
index 197e6c757b000db913684e50915e2f87031ebdc5..0000000000000000000000000000000000000000
--- a/cmake/Modules/FindZLIB.cmake
+++ /dev/null
@@ -1,69 +0,0 @@
-# - Try to find ZLIB
-# Once done this will define
-#
-#  ZLIB_FOUND - system has ZLIB
-#  ZLIB_INCLUDE_DIRS - the ZLIB include directory
-#  ZLIB_LIBRARIES - Link these to use ZLIB
-#  ZLIB_DEFINITIONS - Compiler switches required for using ZLIB
-#
-#  Copyright (c) 2009-2010 Andreas Schneider <mail@cynapses.org>
-#
-#  Redistribution and use is allowed according to the terms of the New
-#  BSD license.
-#  For details see the accompanying COPYING-CMAKE-SCRIPTS file.
-#
-
-
-if (ZLIB_LIBRARIES AND ZLIB_INCLUDE_DIRS)
-  # in cache already
-  set(ZLIB_FOUND TRUE)
-else (ZLIB_LIBRARIES AND ZLIB_INCLUDE_DIRS)
-  if (WIN32)
-    set(_ZLIB_DIR $ENV{PROGRAMFILES}/GnuWin32)
-  endif (WIN32)
-
-  find_path(ZLIB_INCLUDE_DIR
-    NAMES
-      zlib.h
-    PATHS
-      ${_ZLIB_DIR}/include
-      /usr/include
-      /usr/local/include
-      /opt/local/include
-      /sw/include
-      /usr/lib/sfw/include
-  )
-
-  find_library(Z_LIBRARY
-    NAMES
-      z
-      zlib
-      zlib1
-    PATHS
-      ${_ZLIB_DIR}/lib
-      /usr/lib
-      /usr/local/lib
-      /opt/local/lib
-      /sw/lib
-      /usr/sfw/lib/64
-      /usr/sfw/lib
-  )
-
-  set(ZLIB_INCLUDE_DIRS
-    ${ZLIB_INCLUDE_DIR}
-  )
-
-  if (Z_LIBRARY)
-    set(ZLIB_LIBRARIES
-        ${ZLIB_LIBRARIES}
-        ${Z_LIBRARY}
-    )
-  endif (Z_LIBRARY)
-
-  include(FindPackageHandleStandardArgs)
-  find_package_handle_standard_args(ZLIB DEFAULT_MSG ZLIB_LIBRARIES ZLIB_INCLUDE_DIRS)
-
-  # show the ZLIB_INCLUDE_DIRS and ZLIB_LIBRARIES variables only in the advanced view
-  mark_as_advanced(ZLIB_INCLUDE_DIRS ZLIB_LIBRARIES)
-
-endif (ZLIB_LIBRARIES AND ZLIB_INCLUDE_DIRS)
diff --git a/specs/pki-console.spec b/specs/pki-console.spec
index bda704e9437c75018af1a60a01b6a2c665365fa6..a8b010ea3411e592d697ba83056d8dd019af6df5 100644
--- a/specs/pki-console.spec
+++ b/specs/pki-console.spec
@@ -7,7 +7,7 @@
 
 Name:             pki-console
 Version:          10.0.0
-Release:          %{?relprefix}11%{?prerel}%{?dist}
+Release:          %{?relprefix}12%{?prerel}%{?dist}
 Summary:          Certificate System - PKI Console
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -17,39 +17,24 @@ BuildArch:        noarch
 
 BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 
-BuildRequires:    cmake
+BuildRequires:    cmake >= 2.8.10.1-1
 BuildRequires:    idm-console-framework
 BuildRequires:    java-devel >= 1:1.6.0
 BuildRequires:    ldapjdk
 BuildRequires:    nspr-devel
 BuildRequires:    nss-devel
-%if 0%{?fedora} >= 17
 BuildRequires:    junit
-%else
-BuildRequires:    junit4
-%endif
-%if 0%{?fedora} >= 16
 BuildRequires:    jpackage-utils >= 1.7.5-10
 BuildRequires:    jss >= 4.2.6-24
 BuildRequires:    pki-base >= 10.0.0
-%else
-BuildRequires:    jpackage-utils
-BuildRequires:    jss >= 4.2.6-24
-BuildRequires:    pki-base
-%endif
 
 Requires:         idm-console-framework
 Requires:         java >= 1:1.6.0
 Requires:         ldapjdk
 Requires:         pki-base >= 10.0.0
 Requires:         pki-console-theme >= 9.0.0
-%if 0%{?fedora} >= 16
 Requires:         jpackage-utils >= 1.7.5-10
 Requires:         jss >= 4.2.6-24
-%else
-Requires:         jpackage-utils
-Requires:         jss >= 4.2.6-24
-%endif
 
 Source0:          http://pki.fedoraproject.org/pki/sources/%{name}/%{name}-%{version}%{?prerel}.tar.gz
 
@@ -102,6 +87,10 @@ cd build
 
 
 %changelog
+* Tue Nov 20 2012 Ade Lee <alee@redhat.com> 10.0.0-0.12.b3
+- Removed conditionals for fedora < 17
+- Update cmake version
+
 * Mon Nov 12 2012 Ade Lee <alee@redhat.com> 10.0.0-0.11.b3
 - Update release to b3
 
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 149191cf8364c8e60601e475186a13def7d265de..22ae5699dacb8f74b49c565e2dfccb4096565dd4 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -22,7 +22,7 @@ Group:            System Environment/Daemons
 
 BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 
-BuildRequires:    cmake
+BuildRequires:    cmake >= 2.8.10.1-1
 BuildRequires:    zip
 BuildRequires:    java-devel >= 1:1.6.0
 BuildRequires:    redhat-rpm-config
@@ -975,6 +975,7 @@ fi
 * Mon Nov 19 2012 Ade Lee <alee@redhat.com> 10.0.0-0.53.b3
 - Cleaned up spec file to provide only support rhel 7+, f17+
 - Added resteasy-base dependency for rhel 7
+- Update cmake version
 
 * Mon Nov 12 2012 Ade Lee <alee@redhat.com> 10.0.0-0.52.b3
 - Update release to b3
diff --git a/specs/pki-ra.spec b/specs/pki-ra.spec
index 0cff1af8962e0aa6d7e145e5f7986619c355a41f..aa5b4516d7ce009f6a4decf074e3163eac322121 100644
--- a/specs/pki-ra.spec
+++ b/specs/pki-ra.spec
@@ -7,7 +7,7 @@
 
 Name:             pki-ra
 Version:          10.0.0
-Release:          %{?relprefix}11%{?prerel}%{?dist}
+Release:          %{?relprefix}12%{?prerel}%{?dist}
 Summary:          Certificate System - Registration Authority
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -17,12 +17,7 @@ BuildArch:        noarch
 
 BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 
-# specify '_unitdir' macro for platforms that don't use 'systemd'
-%if 0%{?rhel} || 0%{?fedora} < 16
-%define           _unitdir /lib/systemd/system
-%endif
-
-BuildRequires:    cmake
+BuildRequires:    cmake  >= 2.8.10.1-1
 BuildRequires:    nspr-devel
 BuildRequires:    nss-devel
 
@@ -34,17 +29,9 @@ Requires:         pki-ra-theme >= 10.0.0
 Requires:         perl-DBD-SQLite
 Requires:         sqlite
 Requires:         /usr/sbin/sendmail
-%if 0%{?fedora} >= 16
 Requires(post):   systemd-units
 Requires(preun):  systemd-units
 Requires(postun): systemd-units
-%else
-Requires(post):   chkconfig
-Requires(preun):  chkconfig
-Requires(preun):  initscripts
-Requires(postun): initscripts
-Requires:         initscripts
-%endif
 
 Source0:          http://pki.fedoraproject.org/pki/sources/%{name}/%{name}-%{version}%{?prerel}.tar.gz
 
@@ -133,7 +120,6 @@ chmod 755 %{buildroot}%{_datadir}/pki/ra/docroot/ee/scep/*.cgi
 chmod 755 %{buildroot}%{_datadir}/pki/ra/docroot/ee/server/*.cgi
 chmod 755 %{buildroot}%{_datadir}/pki/ra/docroot/ee/user/*.cgi
 
-%if 0%{?fedora} >= 15
 # Details:
 #
 #     * https://fedoraproject.org/wiki/Features/var-run-tmpfs
@@ -145,34 +131,9 @@ echo "D /var/lock/pki 0755 root root -"    >  %{buildroot}%{_sysconfdir}/tmpfile
 echo "D /var/lock/pki/ra 0755 root root -" >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-ra.conf
 echo "D /var/run/pki 0755 root root -"     >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-ra.conf
 echo "D /var/run/pki/ra 0755 root root -"  >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-ra.conf
-%endif
 
-%if 0%{?fedora} >= 16
 %{__rm} %{buildroot}%{_initrddir}/pki-rad
-%else
-%{__rm} -rf %{buildroot}%{_sysconfdir}/systemd/system/pki-rad.target.wants
-%{__rm} -rf %{buildroot}%{_unitdir}
-%endif
 
-%if 0%{?rhel} || 0%{?fedora} < 16
-%post
-# This adds the proper /etc/rc*.d links for the script
-/sbin/chkconfig --add pki-rad || :
-
-
-%preun
-if [ $1 = 0 ] ; then
-    /sbin/service pki-rad stop >/dev/null 2>&1
-    /sbin/chkconfig --del pki-rad || :
-fi
-
-
-%postun
-if [ "$1" -ge "1" ] ; then
-    /sbin/service pki-rad condrestart >/dev/null 2>&1 || :
-fi
-
-%else
 %post
 # Attempt to update ALL old "RA" instances to "systemd"
 if [ -d /etc/sysconfig/pki/ra ]; then
@@ -211,19 +172,14 @@ fi
 if [ "$1" -ge "1" ] ; then
     /bin/systemctl try-restart pki-rad.target >/dev/null 2>&1 || :
 fi
-%endif
 
 
 %files
 %defattr(-,root,root,-)
 %doc base/ra/LICENSE
-%if 0%{?fedora} >= 16
 %dir %{_sysconfdir}/systemd/system/pki-rad.target.wants
 %{_unitdir}/pki-rad@.service
 %{_unitdir}/pki-rad.target
-%else
-%{_initrddir}/pki-rad
-%endif
 %dir %{_datadir}/pki/ra
 %{_datadir}/pki/ra/conf/
 %{_datadir}/pki/ra/docroot/
@@ -232,17 +188,19 @@ fi
 %{_datadir}/pki/ra/setup/
 %dir %{_localstatedir}/lock/pki/ra
 %dir %{_localstatedir}/run/pki/ra
-%if 0%{?fedora} >= 15
 # Details:
 #
 #     * https://fedoraproject.org/wiki/Features/var-run-tmpfs
 #     * https://fedoraproject.org/wiki/Tmpfiles.d_packaging_draft
 #
 %config(noreplace) %{_sysconfdir}/tmpfiles.d/pki-ra.conf
-%endif
 
 
 %changelog
+* Tue Nov 20 2012 Ade Lee <alee@redhat.com> 10.0.0-0.12.b3
+- Update spec fiel to support fedora >= 17 and rhel 7+
+- Update cmake version
+
 * Mon Nov 12 2012 Ade Lee <alee@redhat.com> 10.0.0-0.11.b3
 - Update release to b3
 
diff --git a/specs/pki-tps.spec b/specs/pki-tps.spec
index ac1f4dc57c38925fce5b27cbe9bc4eb6fe288fbb..8f014e692180a9cc8e6d2b65432229d7db2fdda4 100644
--- a/specs/pki-tps.spec
+++ b/specs/pki-tps.spec
@@ -7,7 +7,7 @@
 
 Name:             pki-tps
 Version:          10.0.0
-Release:          %{?relprefix}11%{?prerel}%{?dist}
+Release:          %{?relprefix}12%{?prerel}%{?dist}
 Summary:          Certificate System - Token Processing System
 URL:              http://pki.fedoraproject.org/
 License:          LGPLv2
@@ -15,12 +15,7 @@ Group:            System Environment/Daemons
 
 BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 
-# specify '_unitdir' macro for platforms that don't use 'systemd'
-%if 0%{?rhel} || 0%{?fedora} < 16
-%define           _unitdir /lib/systemd/system
-%endif
-
-BuildRequires:    cmake
+BuildRequires:    cmake >= 2.8.10.1-1
 BuildRequires:    apr-devel
 BuildRequires:    apr-util-devel
 BuildRequires:    cyrus-sasl-devel
@@ -41,17 +36,9 @@ Requires:         perl-Mozilla-LDAP
 Requires:         pki-server >= 10.0.0
 Requires:         pki-tps-theme >= 10.0.0
 
-%if 0%{?fedora} >= 16
 Requires(post):   systemd-units
 Requires(preun):  systemd-units
 Requires(postun): systemd-units
-%else
-Requires(post):   chkconfig
-Requires(preun):  chkconfig
-Requires(preun):  initscripts
-Requires(postun): initscripts
-Requires:         initscripts
-%endif
 
 Source0:          http://pki.fedoraproject.org/pki/sources/%{name}/%{name}-%{version}%{?prerel}.tar.gz
 
@@ -160,7 +147,6 @@ cd %{buildroot}/%{_datadir}/pki/tps/docroot
 mkdir %{buildroot}%{_sysconfdir}/ld.so.conf.d
 echo %{_libdir}/tps > %{buildroot}%{_sysconfdir}/ld.so.conf.d/tps-%{_arch}.conf
 
-%if 0%{?fedora} >= 15
 # Details:
 #
 #     * https://fedoraproject.org/wiki/Features/var-run-tmpfs
@@ -172,36 +158,9 @@ echo "D /var/lock/pki 0755 root root -"     >  %{buildroot}%{_sysconfdir}/tmpfil
 echo "D /var/lock/pki/tps 0755 root root -" >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-tps.conf
 echo "D /var/run/pki 0755 root root -"      >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-tps.conf
 echo "D /var/run/pki/tps 0755 root root -"  >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-tps.conf
-%endif
 
-%if 0%{?fedora} >= 16
 %{__rm} %{buildroot}%{_initrddir}/pki-tpsd
-%else
-%{__rm} -rf %{buildroot}%{_sysconfdir}/systemd/system/pki-tpsd.target.wants
-%{__rm} -rf %{buildroot}%{_unitdir}
-%endif
 
-
-%if 0%{?rhel} || 0%{?fedora} < 16
-%post
-/sbin/ldconfig
-# This adds the proper /etc/rc*.d links for the script
-/sbin/chkconfig --add pki-tpsd || :
-
-
-%preun
-if [ $1 = 0 ] ; then
-    /sbin/service pki-tpsd stop >/dev/null 2>&1
-    /sbin/chkconfig --del pki-tpsd || :
-fi
-
-
-%postun
-if [ "$1" -ge "1" ] ; then
-    /sbin/service pki-tpsd condrestart >/dev/null 2>&1 || :
-fi
-
-%else
 %post
 # Attempt to update ALL old "TPS" instances to "systemd"
 if [ -d /etc/sysconfig/pki/tps ]; then
@@ -240,18 +199,13 @@ fi
 if [ "$1" -ge "1" ] ; then
     /bin/systemctl try-restart pki-tpsd.target >/dev/null 2>&1 || :
 fi
-%endif
 
 %files
 %defattr(-,root,root,-)
 %doc base/tps/LICENSE
-%if 0%{?fedora} >= 16
 %dir %{_sysconfdir}/systemd/system/pki-tpsd.target.wants
 %{_unitdir}/pki-tpsd@.service
 %{_unitdir}/pki-tpsd.target
-%else
-%{_initrddir}/pki-tpsd
-%endif
 %config(noreplace) %{_sysconfdir}/ld.so.conf.d/tps-%{_arch}.conf
 %{_bindir}/tpsclient
 %{_libdir}/httpd/modules/*
@@ -267,17 +221,19 @@ fi
 %{_datadir}/pki/tps/setup/
 %dir %{_localstatedir}/lock/pki/tps
 %dir %{_localstatedir}/run/pki/tps
-%if 0%{?fedora} >= 15
 # Details:
 #
 #     * https://fedoraproject.org/wiki/Features/var-run-tmpfs
 #     * https://fedoraproject.org/wiki/Tmpfiles.d_packaging_draft
 #
 %config(noreplace) %{_sysconfdir}/tmpfiles.d/pki-tps.conf
-%endif
 
 
 %changelog
+* Tue Nov 20 2012 Ade Lee <alee@redhat.com> 10.0.0-0.12.b3
+- Update spec fiel to support fedora >= 17 and rhel 7+
+- Update cmake version
+
 * Mon Nov 12 2012 Ade Lee <alee@redhat.com> 10.0.0-0.11.b3
 - Update release to b3
 
-- 
1.7.11.7