From 865ea68fcf50bec019338e656eccc2f9c60a070a Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Fri, 2 Nov 2012 16:09:50 -0400
Subject: [PATCH] Updated rootca.gif and sub.gif paths.

---
 dogtag/common-ui/shared/admin/console/config/hierarchypanel.vm        | 4 ++--
 dogtag/ra-ui/shared/docroot/ra/admin/console/config/hierarchypanel.vm | 4 ++--
 .../tps-ui/shared/docroot/tps/admin/console/config/hierarchypanel.vm  | 4 ++--
 3 files changed, 6 insertions(+), 6 deletions(-)

diff --git a/dogtag/common-ui/shared/admin/console/config/hierarchypanel.vm b/dogtag/common-ui/shared/admin/console/config/hierarchypanel.vm
index 64b77a8bd7f150368ab2fb59dcbbc39cd4d988f7..e6c03a6b1ede4464106aa564abd8f59266e1b598 100644
--- a/dogtag/common-ui/shared/admin/console/config/hierarchypanel.vm
+++ b/dogtag/common-ui/shared/admin/console/config/hierarchypanel.vm
@@ -49,8 +49,8 @@ The PKI hierarchy establishes the trust relationships between this CA instance a
 </div>
 
 <p>
-<b><input $check_root type=radio name=choice value="root">&nbsp;Make this a Self-Signed Root CA within this new PKI hierarchy. <img alt="" src="../img/rootca.gif"></b>
+<b><input $check_root type=radio name=choice value="root">&nbsp;Make this a Self-Signed Root CA within this new PKI hierarchy. <img alt="" src="/pki/images/rootca.gif"></b>
 <p>
-<b><input $check_join type=radio name=choice value="join">&nbsp;Make this a subordinate CA of another CA. <img alt="" src="../img/sub.gif"></b>
+<b><input $check_join type=radio name=choice value="join">&nbsp;Make this a subordinate CA of another CA. <img alt="" src="/pki/images/sub.gif"></b>
 
 <p>
diff --git a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/hierarchypanel.vm b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/hierarchypanel.vm
index bde310882e143e43c4d727e9fd17ea96b5d13b23..41cba696dd79bda056a256166dce95e71daea734 100644
--- a/dogtag/ra-ui/shared/docroot/ra/admin/console/config/hierarchypanel.vm
+++ b/dogtag/ra-ui/shared/docroot/ra/admin/console/config/hierarchypanel.vm
@@ -58,9 +58,9 @@ The PKI hierarchy establishes the trust relationships between this CA instance a
 </div>
 
 <p>
-<b><input $check_root type=radio name=choice value="root" onChange="setURL();">&nbsp;Make this a Self-Signed Root CA within this new PKI hierarchy. <img alt="" src="rootca.gif"></b>
+<b><input $check_root type=radio name=choice value="root" onChange="setURL();">&nbsp;Make this a Self-Signed Root CA within this new PKI hierarchy. <img alt="" src="/pki/images/rootca.gif"></b>
 <p>
-<b><input $check_join type=radio name=choice value="join" onChange="setURL();">&nbsp;Make this a subordinate CA of another CA. <img alt="" src="sub.gif"></b>
+<b><input $check_join type=radio name=choice value="join" onChange="setURL();">&nbsp;Make this a subordinate CA of another CA. <img alt="" src="/pki/images/sub.gif"></b>
 
     <table class="details">
       <tr>
diff --git a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/hierarchypanel.vm b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/hierarchypanel.vm
index 41d241c477353a34be35135c144a9774f4d7bb53..0138188e9071e2ee726dfa4a6b3ad6181281c693 100644
--- a/dogtag/tps-ui/shared/docroot/tps/admin/console/config/hierarchypanel.vm
+++ b/dogtag/tps-ui/shared/docroot/tps/admin/console/config/hierarchypanel.vm
@@ -57,9 +57,9 @@ The PKI hierarchy establishes the trust relationships between this CA instance a
 </div>
 
 <p>
-<b><input $check_root type=radio name=choice value="root" onChange="setURL();">&nbsp;Make this a Self-Signed Root CA within this new PKI hierarchy. <img alt="" src="rootca.gif"></b>
+<b><input $check_root type=radio name=choice value="root" onChange="setURL();">&nbsp;Make this a Self-Signed Root CA within this new PKI hierarchy. <img alt="" src="/pki/images/rootca.gif"></b>
 <p>
-<b><input $check_join type=radio name=choice value="join" onChange="setURL();">&nbsp;Make this a subordinate CA of another CA. <img alt="" src="sub.gif"></b>
+<b><input $check_join type=radio name=choice value="join" onChange="setURL();">&nbsp;Make this a subordinate CA of another CA. <img alt="" src="/pki/images/sub.gif"></b>
 
     <table class="details">
       <tr>
-- 
1.7.12.1